<template>
  <div>
    <div class="relative mb-4">
      <div
        class="bg-gray-light p-3 inline-block font-medium text-sm text-blue rounded cursor-pointer"
        @click="toggleMenu()"
      >
        <span
          v-if="selectedOption.name !== undefined"
          class="inline-block align-middle"
        >
          {{ selectedOption.name }}
        </span>
        <span v-else class="inline-block align-middle">
          {{ placeholderText }}
        </span>
        <svg-icon
          v-if="!showMenu"
          name="icon-chevron-bottom"
          class="h-3 w-3 ml-1 inline-block align-middle"
        ></svg-icon>
        <svg-icon
          v-else
          name="icon-chevron-top"
          class="h-3 w-3 ml-1 inline-block align-middle"
        ></svg-icon>
      </div>
      <ul
        v-if="showMenu"
        style="top: 110%;min-width: 240px;"
        class="absolute top-0 left-0 bg-gray-light p-3 font-medium text-sm text-blue rounded inline-block space-y-2"
      >
        <li
          v-for="(option, idx) in options"
          :key="idx"
          class="cursor-pointer hover:text-primary"
          @click="updateOption(option)"
        >
          {{ option.name }}
        </li>
      </ul>
    </div>
  </div>
</template>
<script>
export default {
  name: 'DropdownSelect',
  props: {
    options: {
      type: Array,
      default: null
    },
    selected: {
      type: Array,
      default: null
    },
    placeholder: {
      type: String,
      default: ''
    },
    closeOnOutsideClick: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      selectedOption: {
        name: ''
      },
      showMenu: false,
      placeholderText: 'Lựa chọn'
    }
  },
  mounted() {
    this.selectedOption = this.selected
    if (this.placeholder) {
      this.placeholderText = this.placeholder
    }
    if (this.closeOnOutsideClick) {
      document.addEventListener('click', this.clickHandler)
    }
  },
  beforeDestroy() {
    document.removeEventListener('click', this.clickHandler)
  },
  methods: {
    updateOption(option) {
      this.selectedOption = option
      this.showMenu = false
      this.$emit('updateOption', this.selectedOption)
    },
    toggleMenu() {
      this.showMenu = !this.showMenu
    },
    clickHandler(event) {
      const { target } = event
      const { $el } = this
      if (!$el.contains(target)) {
        this.showMenu = false
      }
    }
  }
}
</script>
